#include <gtkmm.h>
#include <gtkmm/volumebutton.h>

class TopWin : public Gtk::Window {
public:
  TopWin();
  virtual ~TopWin();
  
protected:
  //menubar's widgets
  Glib::RefPtr<Gtk::UIManager> menubar_ui;
  Glib::RefPtr<Gtk::ActionGroup> menubar_action;

  //controlhbox's widgets
  Gtk::Button playbutton, nextbutton, prevbutton, repeatbutton, fullbutton;
  Gtk::VolumeButton volumebutton;
  Gtk::HBox controlhbox;
  Gtk::VBox seekvbox;
  Gtk::Label seeklabel;
  Gtk::Adjustment progress, volumeadj;
  Gtk::HScale hscale;
  Gtk::Entry searchbox;
  
  //l_scroll - l_treeview
  Gtk::TreeView l_treeview;
  Glib::RefPtr<Gtk::TreeStore> l_model;
  Gtk::ScrolledWindow l_scroll;
  
  class LColumnRecord : public Gtk::TreeModel::ColumnRecord {
  public:
    LColumnRecord() { add(l_expander); add(l_icon); add(l_status); }
    
    Gtk::TreeModelColumn<Glib::ustring> l_expander;
    Gtk::TreeModelColumn< Glib::RefPtr<Gdk::Pixbuf> > l_icon;
    Gtk::TreeModelColumn<Glib::ustring> l_status;
  };
  
  LColumnRecord l_colrec;
  
  //mtl_scroll - mtl_treeview
  Gtk::TreeView mtl_treeview;
  Glib::RefPtr<Gtk::ListStore> mtl_model;
  Gtk::ScrolledWindow mtl_scroll;
  
  class MtlColumnRecord : public Gtk::TreeModel::ColumnRecord {
  public:
    MtlColumnRecord() { add(mtl_artist); }
    
    Gtk::TreeModelColumn<Glib::ustring> mtl_artist;
  };
  
  MtlColumnRecord mtl_colrec;
  
  //mtr_scroll - mtr_treeview
  Gtk::TreeView mtr_treeview;
  Glib::RefPtr<Gtk::ListStore> mtr_model;
  Gtk::ScrolledWindow mtr_scroll;
  
  class MtrColumnRecord : public Gtk::TreeModel::ColumnRecord {
  public:
    MtrColumnRecord() { add(mtr_album); }
    
    Gtk::TreeModelColumn<Glib::ustring> mtr_album;
  };
  
  MtrColumnRecord mtr_colrec;
  
  //rt_scroll - rt_treeview
  Gtk::TreeView rt_treeview;
  Glib::RefPtr<Gtk::ListStore> rt_model;
  Gtk::ScrolledWindow rt_scroll;
  
  class RtColumnRecord : public Gtk::TreeModel::ColumnRecord {
  public:
    RtColumnRecord() { add(rt_artist); }
    
    Gtk::TreeModelColumn<Glib::ustring> rt_artist;
  };
  
  RtColumnRecord rt_colrec;
  
  //rb_scroll - rb_treeview
  Gtk::TreeView rb_treeview;
  Glib::RefPtr<Gtk::ListStore> rb_model;
  Gtk::ScrolledWindow rb_scroll;
  
  class RbColumnRecord : public Gtk::TreeModel::ColumnRecord {
  public:
    RbColumnRecord() { add(rb_album); }
    
    Gtk::TreeModelColumn<Glib::ustring> rb_album;
  };
  
  RbColumnRecord rb_colrec;
  
  //mb_scroll - mb_treeview
  Gtk::TreeView mb_treeview;
  Glib::RefPtr<Gtk::ListStore> mb_model;
  Gtk::ScrolledWindow mb_scroll;
  
  class MbColumnRecord : public Gtk::TreeModel::ColumnRecord {
  public:
    MbColumnRecord() { add(mb_status); add(mb_name); add(mb_artist); add(mb_album); add(mb_time); }
    
    Gtk::TreeModelColumn< Glib::RefPtr<Gdk::Pixbuf> > mb_status;
    Gtk::TreeModelColumn<Glib::ustring> mb_name;
    Gtk::TreeModelColumn<Glib::ustring> mb_artist;
    Gtk::TreeModelColumn<Glib::ustring> mb_album;
    Gtk::TreeModelColumn<Glib::ustring> mb_time;
  };
  
  MbColumnRecord mb_colrec;
  
  //videoarea
  Gtk::DrawingArea videoarea;
  
  //infolabel
  Gtk::Label infolabel;
  
  //paned
  Gtk::HPaned tophpaned, subhpaned, mhpaned, submhpaned;
  Gtk::VPaned mvpaned, rvpaned;
  Gtk::VBox topvbox;
};
